theory Examples 
imports Main "~~/src/Tools/Apply_Trace/Apply_Trace_Cmd"
  (*see David Greenaway http://stackoverflow.com/a/26827242/570879 *)
  Parity
begin

section {* Examples from Schreiner's lecture notes "Logic and proving" *}
subsection {* Trials on lemma on p.24 *}

(* version 1 *)
lemma 
assumes 1: "\<exists>x. \<forall>y. P x y"
shows "\<forall>y. \<exists>x. P x y"
proof -
  fix x\<^sub>0 :: 'a
  from 1 have 2: "\<forall>y. P x\<^sub>0 y" sorry (* x\<^sub>0 is NOT related to \<exists>x *)
(*from 2 have 3: "P x\<^sub>0 y\<^sub>0" sorry
  from 3 show ?thesis by blast*)
oops

(* version 2 following prog-prove.pdf p.46 *)
lemma 
assumes 1: "\<exists>x. \<forall>y. P x y"
shows "\<forall>y. \<exists>x. P x y"
proof -
  from 1 obtain x\<^sub>0 where 2: "\<forall>y. P x\<^sub>0 y" by auto (*...prog-prove.pdf p.46 *)
  from 2 have 3: "P x\<^sub>0 y\<^sub>0" by auto
  from 2 show ?thesis by auto (* see version 3 *)
qed

(* version 3 identifies an inaccuracy in last step of proof *)
lemma 
assumes 1: "\<exists>x. \<forall>y. P x y"
shows "\<forall>y. \<exists>x. P x y"
proof -
  fix "y\<^sub>0"
  from 1 obtain x\<^sub>0 where 2: "\<forall>y. P x\<^sub>0 y" by (rule exE)
  from 2 have 3: "P x\<^sub>0 y\<^sub>0" by (rule allE)
(* from 3 show ?thesis by (rule allI)  why not ??? *)
oops
declare[[show_brackets]]
thm allI --{*((\<And>x. (?P x)) \<Longrightarrow> (\<forall>x. (?P x)))*}
print_statement allI
(*theorem allI:
  fixes P :: "('a \<Rightarrow> bool)" 
  assumes "(\<And>x. (P x))"
  shows "(\<forall>x. (P x))"*)
term    "\<exists>x.  P x    \<Longrightarrow>  (\<And>x.   P x  \<Longrightarrow>  Q)  \<Longrightarrow>  Q" 
-- {*" ((\<exists>x. (P x))  \<Longrightarrow> ((\<And>x. ((P x) \<Longrightarrow>  Q)) \<Longrightarrow>  Q)) "*}
thm exE --{*\<exists>x. ?P x \<Longrightarrow>  (\<And>x.  ?P x  \<Longrightarrow> ?Q)  \<Longrightarrow> ?Q*}
print_statement exE
(*theorem exE:
  fixes P :: "'a \<Rightarrow> bool" 
  assumes "\<exists>x. P x"
  obtains x :: "'a" where "P x"     ... *)
thm allE --{*\<forall>x. ?P x \<Longrightarrow> (?P ?x \<Longrightarrow> ?R) \<Longrightarrow> ?R*}
print_statement allE
(*theorem allE:
  fixes P :: "'a \<Rightarrow> bool" 
    and x :: "'a" 
  assumes "\<forall>x. P x"
  obtains "P x" *)

term "\<exists>x. \<forall>y. P x y \<longrightarrow> (\<forall>y. \<exists>x. P x y)"

lemma 
  shows "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)" (is "?prem \<longrightarrow> ?concl") (*prog-prove p.46*)
proof -
  fix "y\<^sub>0" assume 1: "?prem"
  from 1 obtain x\<^sub>0 where 2: "\<forall>y. P x\<^sub>0 y" by (rule exE)
  from 2 have 3: "P x\<^sub>0 y\<^sub>0" by (rule allE)
(*from 3 show ?concl by sorry by (rule allI)  ... why not ??? *)
oops

section {* Examples from Schreiner/Windsteiger "First Order Predicate Logic"*}
subsection {* Trials on lemma on p.8 *}

term even
value "True | False"
value "even (1234 :: int)" 
value "abs (-123 :: int)"

thm conjI
declare[[show_types]]
lemma "\<forall>n :: int. even n \<longrightarrow> (\<exists>k l. n = k + l \<and> odd k \<and> odd l \<and> \<bar>k - l\<bar> \<le> 2)"
proof -
  fix n :: int
  assume 1: "even n"
(*show "\<exists>k l. n = k + l \<and> odd k  \<and> odd l  \<and> \<bar>k - l\<bar> \<le> 2"*)
oops

end
